// ignore_for_file: public_member_api_docs, sort_constructors_first
// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:http/http.dart';
import 'package:wyatt_http_client/src/utils/http_status.dart';

class MiddlewareResponse {
  BaseResponse httpResponse;

  // Proxy
  int get statusCode => httpResponse.statusCode;
  HttpStatus get status => HttpStatus.from(statusCode);
  String get body {
    if (httpResponse is Response) {
      return (httpResponse as Response).body;
    } else {
      return '';
    }
  }
  int? get contentLength => httpResponse.contentLength;
  Map<String, String> get headers => httpResponse.headers;

  MiddlewareResponse({
    required this.httpResponse,
  });

  MiddlewareResponse copyWith({
    BaseResponse? httpResponse,
  }) => MiddlewareResponse(
      httpResponse: httpResponse ?? this.httpResponse,
    );

  @override
  String toString() =>
      'MiddlewareResponse(httpResponse: $httpResponse)';
}
